//+------------------------------------------------------------------+
//|                                                     All trix.mq4 |
//+------------------------------------------------------------------+
#property copyright   "mladen"
#property link        "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Red
#property indicator_color2 Maroon
#property indicator_color3 LimeGreen
#property indicator_color4 Green
#property indicator_color5 Gold
#property indicator_color6 Green
#property indicator_width1 2
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 1
#property indicator_width5 2
#property indicator_width6 2

//
//
//
//
//
//

extern int    T3FastPeriod     = 20;
extern int    T3FastPrice      = PRICE_CLOSE;
extern double T3FastHot        = 1.2;
extern bool   T3FastOriginal   = false;
extern bool   T3FastAdaptive   = true;
extern int    T3SlowPeriod     = 35;
extern int    T3SlowPrice      = PRICE_CLOSE;
extern double T3SlowHot        = 1.2;
extern bool   T3SlowOriginal   = false;
extern bool   T3SlowAdaptive   = true;
extern string TimeFrames       = "M1;M5;M15;M30;H1;H4;D1;W1;MN";
extern int    barsPerTimeFrame = 35;
extern bool   equalize         = true;
extern bool   shiftRight       = false; 
extern bool   currentFirst     = true; 
extern color  txtColor         = Silver; 
extern color  separatorColor   = DimGray; 
extern string UnqueID          = "AllT3Trix1";

//
//
//
//
//
//

double t3gCross[];
double t3rCross[];
double upBuffer1[];
double upBuffer2[];
double dnBuffer1[];
double dnBuffer2[];
double t3diff[];
double trend[];

//
//
//
//
//

string indicatorName;
string shortName;
string labels[];
int    periods[];
int    Shift;
double minValue;
double maxValue;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   indicatorName  = WindowExpertName();
   calculateValue = (TimeFrames=="calculateValue");
      if (shiftRight) Shift = 1;
      else            Shift = 0;
            barsPerTimeFrame = MathMax(barsPerTimeFrame,15);      
            shortName = UnqueID+" ("+T3FastPeriod+","+T3SlowPeriod+")";
                        IndicatorShortName(shortName);
   
      //
      //
      //
      //
      //
      
      IndicatorBuffers(8);
         SetIndexBuffer(0,dnBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
         SetIndexBuffer(1,dnBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
         SetIndexBuffer(2,upBuffer1); SetIndexStyle(2,DRAW_HISTOGRAM);
         SetIndexBuffer(3,upBuffer2); SetIndexStyle(3,DRAW_HISTOGRAM);
         SetIndexBuffer(4,t3rCross);  SetIndexLabel(4,"T3 trix "+T3SlowPeriod);
         SetIndexBuffer(5,t3gCross);  SetIndexLabel(5,"T3 trix "+T3FastPeriod);   
         SetIndexBuffer(6,t3diff);  
         SetIndexBuffer(7,trend);

            if (calculateValue) return(0);

      //
      //
      //
      //
      //
      
      TimeFrames = StringTrimLeft(StringTrimRight(TimeFrames));
      if (StringSubstr(TimeFrames,StringLen(TimeFrames),1) != ";")
                       TimeFrames = StringConcatenate(TimeFrames,";");

         //
         //
         //
         //
         //                                   
            
         int s = 0;
         int i = StringFind(TimeFrames,";",s);
         int time;
         string current;
            while (i > 0)
            {
               current = StringSubstr(TimeFrames,s,i-s);
               time    = stringToTimeFrame(current);
               if (time > 0) {
                     ArrayResize(labels ,ArraySize(labels)+1);
                     ArrayResize(periods,ArraySize(periods)+1);
                                 labels[ArraySize(labels)-1]   = timeFrameToString(time); 
                                 periods[ArraySize(periods)-1] = time; }
                                 s = i + 1;
                                     i = StringFind(TimeFrames,";",s);
            }
      
      //
      //
      //
      //
      //

      if(currentFirst)
         for (i=1;i<ArraySize(periods);i++)
         if (Period()==periods[i])
            {
               string tmpLbl = labels[i];
               int    tmpPer = periods[i];
               
               //
               //
               //
               //
               //
               
               for (int k=i ;k>0; k--)
                     {
                        labels[k]  = labels[k-1];
                        periods[k] = periods[k-1];
                     }                     
               labels[0]  = tmpLbl;
               periods[0] = tmpPer;
            }
   return(0);
}

//
//
//
//
//

int deinit()
{
   for(int l=0;l<ArraySize(periods);l++) {
         ObjectDelete(UnqueID+l);
         ObjectDelete(UnqueID+l+"label");
      }         
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   if (calculateValue) { calculateTrix(); return(0); }
     string separator;
     int    window=WindowFind(shortName);
     int    k=0;

     //
     //
     //
     //
     //

     double maxValues[]; ArrayResize(maxValues,ArraySize(periods));
            minValue =  999999;
            for(int p=0; p<ArraySize(periods);p++)
            {
               maxValue = -999999;
                     for(int i=0; i<barsPerTimeFrame;i++,k++)
                           {
                              t3rCross[k]  = iCustom(NULL,periods[p],indicatorName,T3FastPeriod,T3FastPrice,T3FastHot,T3FastOriginal,T3FastAdaptive,T3SlowPeriod,T3SlowPrice,T3SlowHot,T3SlowOriginal,T3SlowAdaptive,"calculateValue",4,i);
                              t3gCross[k]  = iCustom(NULL,periods[p],indicatorName,T3FastPeriod,T3FastPrice,T3FastHot,T3FastOriginal,T3FastAdaptive,T3SlowPeriod,T3SlowPrice,T3SlowHot,T3SlowOriginal,T3SlowAdaptive,"calculateValue",5,i);
                              trend[k]     = iCustom(NULL,periods[p],indicatorName,T3FastPeriod,T3FastPrice,T3FastHot,T3FastOriginal,T3FastAdaptive,T3SlowPeriod,T3SlowPrice,T3SlowHot,T3SlowOriginal,T3SlowAdaptive,"calculateValue",7,i);
                              t3diff[k]    = t3gCross[k]-t3rCross[k];
                              upBuffer1[k] = EMPTY_VALUE;
                              upBuffer2[k] = EMPTY_VALUE;
                              dnBuffer1[k] = EMPTY_VALUE;
                              dnBuffer2[k] = EMPTY_VALUE;
                              
                                 if (t3diff[k]>0)
                                    if (trend[k] == 1)
                                          upBuffer1[k] = t3diff[k];
                                    else  upBuffer2[k] = t3diff[k];
                                 else               
                                    if (trend[k] == 1)
                                          dnBuffer2[k] = t3diff[k];
                                    else  dnBuffer1[k] = t3diff[k];
                               checkMinMax(k);
                           }
                           upBuffer1[k] = EMPTY_VALUE;
                           upBuffer2[k] = EMPTY_VALUE;
                           dnBuffer1[k] = EMPTY_VALUE;
                           dnBuffer2[k] = EMPTY_VALUE;
                           t3rCross[k]  = EMPTY_VALUE;
                           t3gCross[k]  = EMPTY_VALUE;
                           t3diff[k]    = EMPTY_VALUE;
                           maxValues[p] = maxValue;
                           k += 1;
                           
                           //
                           //
                           //
                           //
                           //
                           
                           separator = UnqueID+p;
                           if(ObjectFind(separator)==-1)
                              ObjectCreate(separator,OBJ_TREND,window,0,0);
                              ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-1));
                              ObjectSet(separator,OBJPROP_TIME2,barTime(k-Shift*(barsPerTimeFrame+1)-1));
                              ObjectSet(separator,OBJPROP_COLOR ,separatorColor);
                              ObjectSet(separator,OBJPROP_WIDTH ,2);
                           separator = UnqueID+p+"label";
                           if(ObjectFind(separator)==-1)
                              ObjectCreate(separator,OBJ_TEXT,window,0,0);
                              ObjectSet(separator,OBJPROP_TIME1,barTime(k-Shift*(barsPerTimeFrame+1)-5));
                              ObjectSetText(separator,labels[p],9,"Arial",txtColor);
                  }

         //
         //
         //
         //
         //

         k = 0; maxValue = 0;
         double koef  = 1;
         for(i=0; i<ArraySize(periods); i++) if (maxValue < maxValues[i]) maxValue = maxValues[i];
         for(p=0; p<ArraySize(periods); p++) 
         {
               separator = UnqueID+p;
                  ObjectSet(separator,OBJPROP_PRICE1,maxValue);
                  ObjectSet(separator,OBJPROP_PRICE2,minValue);
               separator = UnqueID+p+"label";
                  ObjectSet(separator,OBJPROP_PRICE1,maxValue);
               if (equalize) koef = maxValue/maxValues[p];
          
               //
               //
               //
               //
               //
                    
                  for(i=0; i<barsPerTimeFrame;i++,k++)
                  {
                     t3rCross[k] = t3rCross[k]*koef;
                     t3gCross[k] = t3gCross[k]*koef;
                     t3diff[k]   = t3diff[k]  *koef;
                        if (upBuffer1[k] != EMPTY_VALUE) upBuffer1[k] = upBuffer1[k]*koef;
                        if (upBuffer2[k] != EMPTY_VALUE) upBuffer2[k] = upBuffer2[k]*koef;
                        if (dnBuffer1[k] != EMPTY_VALUE) dnBuffer1[k] = dnBuffer1[k]*koef;
                        if (dnBuffer2[k] != EMPTY_VALUE) dnBuffer2[k] = dnBuffer2[k]*koef;
                  }                  
                  k++;
            }                  

      //
      //
      //
      //
      //
      
      SetIndexDrawBegin(0,Bars-k);
      SetIndexDrawBegin(1,Bars-k);              
   return(0);
}



//+------------------------------------------------------------------+
//+                                                                  +
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][2];

//
//
//
//
//

void calculateTrix()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
       
         work[r][0]   = iT3a(iMA(NULL,0,1,0,MODE_SMA,T3FastPrice,i),T3FastPeriod,T3FastHot,T3FastOriginal,T3FastAdaptive,i,0);  
         work[r][1]   = iT3a(iMA(NULL,0,1,0,MODE_SMA,T3SlowPrice,i),T3SlowPeriod,T3SlowHot,T3SlowOriginal,T3SlowAdaptive,i,1);
         t3gCross[i]  = work[r][0]-work[r-1][0];
         t3rCross[i]  = work[r][1]-work[r-1][1];
         t3diff[i]    = t3gCross[i]-t3rCross[i];
         upBuffer1[i] = EMPTY_VALUE;
         upBuffer2[i] = EMPTY_VALUE;
         dnBuffer1[i] = EMPTY_VALUE;
         dnBuffer2[i] = EMPTY_VALUE;
         trend[i]     = trend[i+1];
            if (t3diff[i]>t3diff[i+1]) trend[i] =  1;
            if (t3diff[i]<t3diff[i+1]) trend[i] = -1;
            if (t3diff[i]>0)
               if (trend[i] == 1)
                     upBuffer1[i] = t3diff[i];
               else  upBuffer2[i] = t3diff[i];
            else               
               if (trend[i] == 1)
                     dnBuffer2[i] = t3diff[i];
               else  dnBuffer1[i] = t3diff[i];
      }
}

//
//
//
//
//

double workT3[][14];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5
#define _atr    6

//
//
//
//
//

double iT3a(double price, double period, double hot, bool original, bool adaptive, int i, int forInstance=0)
{
   int r      = Bars-i-1;
   int buffer = forInstance*7;

   //
   //
   //
   //
   //
   
      if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
      if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);
      if (adaptive)
      {
         workT3[r][_atr+buffer] = iATR(NULL,0,period,i);
            double max = workT3[r][_atr+buffer];
            double min = workT3[r][_atr+buffer];
            for (int k=1; k<period && (r-k>=0); k++)
               {
                  max = MathMax(max,workT3[r-k][_atr+buffer]);
                  min = MathMin(min,workT3[r-k][_atr+buffer]);
               }
            if (min!=max)
                  double atn = 1.0-(workT3[r][_atr+buffer]-min)/(max-min);
            else         atn = 0.5;
            period = period*(atn+1.0)/2.0;
      }
   
   //
   //
   //
   //
   //
   
      if (workT3Coeffs[forInstance][_period] != period)
      {
        workT3Coeffs[forInstance][_period] = period;
           double a = hot;
               workT3Coeffs[forInstance][_c1] = -a*a*a;
               workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
               workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
               workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
               if (original)
                    workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
               else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
      }
   
   //
   //
   //
   //
   //
   
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[r][2+buffer]);
}

//+------------------------------------------------------------------+
//+                                                                  +
//+------------------------------------------------------------------+
//
//
//
//
//

void checkMinMax(int shift)
{
   double tmpMin;
   double tmpMax;
   
   tmpMin = MathMin(MathMin(t3rCross[shift],t3gCross[shift]),t3diff[shift]);
   tmpMax = MathMax(MathMax(t3rCross[shift],t3gCross[shift]),t3diff[shift]);
            minValue = MathMin(tmpMin,minValue);
            maxValue = MathMax(tmpMax,maxValue);
}

//
//
//
//
//

int barTime(int a)
{
   if(a<0)
         return(Time[0]+Period()*60*MathAbs(a));
   else  return(Time[a]);   
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(iTfTable[i]);
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

